﻿@model Detech_Conference.Class.Details

@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}



<body>

    <div id="MachineInformation" class="col-sm-12">
        <div id="information" class="panel panel-container">
            <div class="row">
                <div class="col-xs-6 col-md-4 col-lg-4 no-padding">
                    <div class="panel panel-teal panel-widget border-right">
                        <div class="row no-padding">
                            <div class="text-muted">Product Name</div>
                            <h4 class="timeline-title">@Model.ProductName</h4>

                        </div>
                    </div>
                </div>
                <div class="col-xs-6 col-md-4 col-lg-4 no-padding">
                    <div class="panel panel-teal panel-widget border-right">
                        <div class="row no-padding">
                            <div class="text-muted">Status</div>
                            @{
                                if (Model.MachineState == "Stop")
                                {
                                    <h4 class="timeline-title" style="text-transform:uppercase;"><font size="4" style="font-weight:bold"><mark style="background-color:red; padding-left: 10px; padding-right: 10px;">@Model.MachineState</mark></font></h4>
                                }
                                if (Model.MachineState == "Start")
                                {
                                    <h4 class="timeline-title" style="text-transform:uppercase;"><font size="4" style="font-weight:bold"><mark style="background-color:#009933; padding-left: 10px; padding-right: 10px;">@Model.MachineState</mark></font></h4>
                                }
                                if (Model.MachineState == "Alarm")
                                {
                                    <h4 class="timeline-title" style="text-transform:uppercase;"><font size="4" style="font-weight:bold"><mark style="background-color:#b3b3b3; padding-left: 10px; padding-right: 10px;">@Model.MachineState</mark></font></h4>
                                }
                                if (Model.MachineState == "Maintenance")
                                {
                                    <h4 class="timeline-title" style="text-transform:uppercase;"><font size="4" style="font-weight:bold"><mark style="background-color:#ff9900; padding-left: 10px; padding-right: 10px;">@Model.MachineState</mark></font></h4>
                                }
                            }


                        </div>
                    </div>
                </div>
                <div class="col-xs-6 col-md-4 col-lg-4 no-padding">
                    <div class="panel panel-teal panel-widget border-right">
                        <div class="row no-padding">
                            <div class="text-muted">Operation Since</div>
                            <h4 class="timeline-title">@Model.MachineStateTime </h4>

                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div id="ProductionEfficiency" class="row">
            <div class="col-xs-6 col-md-3">
                <div class="panel panel-default">
                    <div class="panel-body easypiechart-panel">
                        <h4><b>OEE</b></h4>
                        <div class="oeeChart" id="oeeGauge" style="padding-bottom:34px"></div>
                    </div>
                </div>
            </div>
            <div class="col-xs-6 col-md-3">
                <div class="panel panel-default">
                    <div class="panel-body easypiechart-panel">
                        <h4><b>Availability</b></h4>
                        <div id="chartdiv"></div>
                    </div>
                </div>
            </div>
            <div class="col-xs-6 col-md-3">
                <div class="panel panel-default">
                    <div class="panel-body easypiechart-panel">
                        <h4><b>Performance</b></h4>
                        <div class="easypiechart" id="easypiechart-orange" data-percent="@Model.performance"><span class="percent" id="performancePercent"></span></div>

                    </div>
                </div>
            </div>
            <div class="col-xs-6 col-md-3">
                <div class="panel panel-default">
                    <div class="panel-body easypiechart-panel">
                        <h4><b>Quality</b></h4>
                        <figure class="highcharts-figure">
                            <div id="container"></div>
                        </figure>
                    </div>
                </div>
            </div>
        </div>

        <div class="panel-body" id="quantityStatus">
            <div class="col-md-12 no-padding">
                <div class="row progress-labels">
                    <div class="col-sm-6" style="font-size:larger;"> <font class="text-muted" style="font-size:x-large;">Actual Quantity:</font>  <b style="font-size:xx-large;">@(Model.GoodParts + Model.BadParts)</b> </div>
                    <div class="col-sm-6" style="text-align: right; font-size:larger;"> <font class="text-muted" style="font-size: x-large;">Target Quantity:</font><b style="font-size: xx-large;"> @Model.PlanTotalProduced</b></div>
                </div>
                <div class="progress">
                    <div data-percentage="0%" style="width: @Model.quantityPercentage%;" class="progress-bar progress-bar-teal" role="progressbar" aria-valuemin="0" aria-valuemax="100"></div>
                </div>
            </div>
        </div>

        <div class="row" id="temperatureBotInformation">
            <div class="col-md-6">
                <div class="panel panel-default">
                    <div class="panel-body" id="BotInformation">
                        <div class="col-xs-6 col-md-12 col-lg-12 no-padding">
                            <div class="panel panel-red panel-widget ">
                                <div class="row no-padding">
                                    <div class="text-muted">Operating Time (in sec)</div>
                                    <div class="large">@Model.RunTime</div>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-6 col-md-6 col-lg-6 no-padding">
                            <div class="panel panel-teal panel-widget border-right">
                                <div class="row no-padding">
                                    <div class="text-muted">Plan Downtime (in sec)</div>
                                    <div class="large">@(Math.Round((Model.MaintenanceTime), 2))</div>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-6 col-md-6 col-lg-6 no-padding">
                            <div class="panel panel-blue panel-widget ">
                                <div class="row no-padding">
                                    <div class="text-muted">Unplan Downtime (in sec)</div>
                                    <div class="large">@(Math.Round((Model.StopTime + Model.AlarmTime), 2))</div>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-6 col-md-6 col-lg-6 no-padding">
                            <div class="panel panel-orange panel-widget border-right">
                                <div class="row no-padding">
                                    <div class="text-muted">Rejection Units</div>
                                    <div class="large">@Model.BadParts</div>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-6 col-md-6 col-lg-6 no-padding">
                            <div class="panel panel-red panel-widget">
                                <div class="row no-padding">
                                    <div class="text-muted">Pass Units</div>
                                    <div class="large">@Model.GoodParts</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6" >
                <div class="panel panel-default">
                    <div class="panel-heading">
                        Temperature Overview
                    </div>
                    <div class="panel-body">
                        <div class="canvas-wrapper" id="temperatureStatus">
                            <canvas class="main-chart" id="line-chart" height="200" width="600"></canvas>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="~/Content/js/jquery-3.3.1.js"></script>
    <script src="~/Content/js/raphaeljs.min.js"></script>
    <script type="text/javascript" src="~/Content/js/kuma-gauge.jquery.js"></script>
    <script src="~/Content/js/HighCharts.js"></script>
    <script src="~/Content/js/HighCharts-more.js"></script>
    <script src="~/Content/js/amChartCore.js"></script>
    <script src="~/Content/js/AmCharts.js"></script>
    <script src="~/Content/js/AmChart-Animated.js"></script>


    <script>
        
        var jsonObj = @Html.Raw(Json.Encode(Model.temperatureValue));
            var listTime = new Array();
            var valueTemperature = new Array();

            for (var key in jsonObj) {
                var completedDateText = jsonObj[key]["time_record"];
                var completedDate = new Date(parseInt(completedDateText.replace("/Date(", "").replace(")/")));
                var d = new Date(completedDate);
                listTime.push(d.toLocaleTimeString().replace("AM", "").replace("PM", ""));
                valueTemperature.push(jsonObj[key]["value"]);
            }

            listTime.reverse();
            valueTemperature.reverse();
            var lineTemperature = {
                labels: listTime,
                datasets: [
                    {
                        label: "Temperature Overview",
                        fillColor: "rgba(48, 164, 255, 0.2)",
                        strokeColor: "rgba(48, 164, 255, 1)",
                        pointColor: "rgba(48, 164, 255, 1)",
                        pointStrokeColor: "#fff",
                        pointHighlightFill: "#fff",
                        pointHighlightStroke: "rgba(48, 164, 255, 1)",
                        data: valueTemperature
                    }]
            }

            window.onload = function () {
                var chart1 = document.getElementById("line-chart").getContext("2d");
                window.myLine = new Chart(chart1).Line(lineTemperature, {
                    responsive: true,
                    scaleLineColor: "rgba(0,0,0,.2)",
                    scaleGridLineColor: "rgba(0,0,0,.05)",
                    scaleFontColor: "#c5c7cc",
                    scaleOverride: true,
                    scaleSteps: 10,
                    scaleStepWidth: 0.5,
                    scaleStartValue: 20

                });
                

            };
        

           
     </script>

    <!-- Update OEE Chart-->
    <script>
        var newValue = 0;
        var test = $('.oeeChart').kumaGauge({
            value: newValue
        });

        $('.oeeChart').kumaGauge('update', {
            value: newValue
        });

        setInterval(function () {
                $.ajax({
                    type: "GET",
                    url: "/OEEDashboard/oeeResult",
                    success: function (data) {
                        test.kumaGauge('update', {value: data.oee})
                    }
                });
            }, 500);

    </script>

    <!-- Update Quality Chart-->
    <script>
        Highcharts.chart('container', {

            chart: {
                type: 'gauge',
                plotBackgroundColor: null,
                plotBackgroundImage: null,
                plotBorderWidth: 0,
                plotShadow: false
            },

            title: {
                text: ''
            },

            pane: {
                startAngle: -150,
                endAngle: 150,
                background: [{
                    backgroundColor: {
                        linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
                        stops: [
                            [0, '#FFF'],
                            [1, '#333']
                        ]
                    },
                    borderWidth: 0,
                    outerRadius: '109%'
                }, {
                    backgroundColor: {
                        linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
                        stops: [
                            [0, '#333'],
                            [1, '#FFF']
                        ]
                    },
                    borderWidth: 1,
                    outerRadius: '107%'
                }, {
                    // default background
                }, {
                    backgroundColor: '#DDD',
                    borderWidth: 0,
                    outerRadius: '105%',
                    innerRadius: '103%'
                }]
            },

            // the value axis
            yAxis: {
                min: 0,
                max: 100,

                minorTickInterval: 'auto',
                minorTickWidth: 1,
                minorTickLength: 10,
                minorTickPosition: 'inside',
                minorTickColor: '#666',

                tickPixelInterval: 30,
                tickWidth: 2,
                tickPosition: 'inside',
                tickLength: 10,
                tickColor: '#666',
                labels: {
                    step: 2,
                    rotation: 'auto'
                },
                title: {
                    text: ''
                },
                plotBands: [{
                    from: 80,
                    to: 100,
                    color: '#55BF3B' // green

                }, {
                    from: 30,
                    to: 80,
                    color: '#DDDF0D' // yellow
                }, {
                    from: 0,
                    to: 30,
                    color: '#DF5353' // red
                }]
            },

            series: [{
                name: 'Quality',
                data: [80],
                tooltip: {
                    valueSuffix: ' %'
                }
            }]

        },
            // Add some life
            function (chart) {
                if (!chart.renderer.forExport) {

                    var point = chart.series[0].points[0],
                        newVal,
                        inc = Math.round((Math.random() - 0.5) * 20);


                    setInterval(function () {
                        $.ajax({
                            type: "GET",
                            url: "/OEEDashboard/oeeResult",
                            success: function (data) {
                                newVal = data.quality
                                point.update(newVal);
                            }
                        });
                    }, 500);

                }
            });
    </script>

    <!-- Update Availability Chart-->
    <script>

        am4core.useTheme(am4themes_animated);

        // create chart
        var chart = am4core.create("chartdiv", am4charts.GaugeChart);
        chart.innerRadius = -15;

        var axis = chart.xAxes.push(new am4charts.ValueAxis());
        axis.min = 0;
        axis.max = 100;
        axis.strictMinMax = true;

        var colorSet = new am4core.ColorSet();

        var gradient = new am4core.LinearGradient();
        gradient.stops.push({ color: am4core.color("red") })
        gradient.stops.push({ color: am4core.color("yellow") })
        gradient.stops.push({ color: am4core.color("green") })

        axis.renderer.line.stroke = gradient;
        axis.renderer.line.strokeWidth = 15;
        axis.renderer.line.strokeOpacity = 1;

        axis.renderer.grid.template.disabled = true;

        var hand = chart.hands.push(new am4charts.ClockHand());
        hand.radius = am4core.percent(97);

        setInterval(function () {
            $.ajax({
                type: "GET",
                url: "/OEEDashboard/oeeResult",
                success: function (data) {
                    hand.showValue(data.availability);
                }
            });
        }, 500);

    </script>

    <!-- Update Performance Chart-->
    <script>
        $(function () {
            var test = $('#easypiechart-orange').easyPieChart({
                scaleColor: false,
                barColor: '#ffb53e'
            });

            setInterval(function () {
                $.ajax({
                    type: "GET",
                    url: "/OEEDashboard/oeeResult",
                    success: function (data) {
                        test.data('easyPieChart').update(data.performance);
                        $('#performancePercent').text(data.performance + "%");
                    }
                });
            }, 500);

        });






    </script>

    <!-- Update Top Information Chart-->
    <script>
        setInterval(function () {
            $.ajax({
                type: "GET",
                url: "/OEEDashboard/TopInformation",
                success: function (data) {
                    $('#information').html(data)
                }
            });
        }, 500);
    </script>

    <!-- Update Quantity Status Chart-->
    <script>
        setInterval(function () {
            $.ajax({
                type: "GET",
                url: "/OEEDashboard/quantity",
                success: function (data) {
                    $('#quantityStatus').html(data)
                }
            });
        }, 500);
    </script>

    <!-- Update Bottom Information & Temperature Chart-->
    <script>
        setInterval(function () {
            $.ajax({
                type: "GET",
                url: "/OEEDashboard/TemperatureBotInformation",
                success: function (data) {
                    $('#temperatureBotInformation').html(data)
                }
            });
        }, 1000);
    </script>



</body>